Update VPP/ODL versions for FDIO scenarios
[apex.git] / lib / overcloud-deploy-functions.sh
1 #!/usr/bin/env bash
2 ##############################################################################
3 # Copyright (c) 2015 Tim Rozet (Red Hat), Dan Radez (Red Hat) and others.
4 #
5 # All rights reserved. This program and the accompanying materials
6 # are made available under the terms of the Apache License, Version 2.0
7 # which accompanies this distribution, and is available at
8 # http://www.apache.org/licenses/LICENSE-2.0
9 ##############################################################################
10
11 ##preping it for deployment and launch the deploy
12 ##params: none
13 function overcloud_deploy {
14   local num_compute_nodes
15   local num_control_nodes
16   local dpdk_cores pmd_cores socket_mem ovs_dpdk_perf_flag ovs_option_heat_arr
17   declare -A ovs_option_heat_arr
18
19   ovs_option_heat_arr['dpdk_cores']=OvsDpdkCoreList
20   ovs_option_heat_arr['pmd_cores']=PmdCoreList
21   ovs_option_heat_arr['socket_memory']=OvsDpdkSocketMemory
22
23   # OPNFV Default Environment and Network settings
24   DEPLOY_OPTIONS+=" -e ${ENV_FILE}"
25   DEPLOY_OPTIONS+=" -e network-environment.yaml"
26
27   # Custom Deploy Environment Templates
28   if [[ "${#deploy_options_array[@]}" -eq 0 || "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
29     if [ "${deploy_options_array['sfc']}" == 'True' ]; then
30       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight_sfc.yaml"
31     elif [ "${deploy_options_array['vpn']}" == 'True' ]; then
32       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-bgpvpn.yaml"
33       if [ "${deploy_options_array['gluon']}" == 'True' ]; then
34         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/services/gluon.yaml"
35       fi
36     elif [ "${deploy_options_array['vpp']}" == 'True' ]; then
37       if [ "${deploy_options_array['odl_vpp_netvirt']}" == "True" ]; then
38         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-netvirt-vpp.yaml"
39       elif [ "${deploy_options_array['sdn_l3']}" == "True" ]; then
40         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb.yaml"
41       else
42         DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-honeycomb-l2.yaml"
43       fi
44     else
45       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-opendaylight-l3.yaml"
46     fi
47     SDN_IMAGE=opendaylight
48   elif [ "${deploy_options_array['sdn_controller']}" == 'opendaylight-external' ]; then
49     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/opendaylight-external.yaml"
50     SDN_IMAGE=opendaylight
51   elif [ "${deploy_options_array['sdn_controller']}" == 'onos' ]; then
52     echo -e "${red}ERROR: ONOS is unsupported in Danube...exiting${reset}"
53     exit 1
54     #if [ "${deploy_options_array['sfc']}" == 'True' ]; then
55     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos_sfc.yaml"
56     #else
57     #  DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/onos.yaml"
58     #fi
59     #SDN_IMAGE=onos
60   elif [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
61     if [[ "$ha_enabled" == "True" ]]; then
62       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn-ha.yaml"
63       echo "${red}OVN HA support is not not supported... exiting.${reset}"
64       exit 1
65     else
66       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-ovn.yaml"
67     fi
68     SDN_IMAGE=opendaylight
69   elif [ "${deploy_options_array['sdn_controller']}" == 'opencontrail' ]; then
70     echo -e "${red}ERROR: OpenContrail is currently unsupported...exiting${reset}"
71     exit 1
72   elif [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
73     echo -e "${blue}INFO: SDN Controller disabled...will deploy nosdn scenario${reset}"
74     if [ "${deploy_options_array['vpp']}" == 'True' ]; then
75       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ml2-vpp.yaml"
76     elif [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
77       DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/neutron-ovs-dpdk.yaml"
78     fi
79     SDN_IMAGE=opendaylight
80   else
81     echo "${red}Invalid sdn_controller: ${deploy_options_array['sdn_controller']}${reset}"
82     echo "${red}Valid choices are opendaylight, opendaylight-external, onos, opencontrail, False, or null${reset}"
83     exit 1
84   fi
85
86   # Enable Tacker
87   if [ "${deploy_options_array['tacker']}" == 'True' ]; then
88     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_tacker.yaml"
89   fi
90
91   # Enable Congress
92   if [ "${deploy_options_array['congress']}" == 'True' ]; then
93     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/enable_congress.yaml"
94   fi
95
96   # Enable Real Time Kernel (kvm4nfv)
97   if [ "${deploy_options_array['rt_kvm']}" == 'True' ]; then
98     DEPLOY_OPTIONS+=" -e /home/stack/enable_rt_kvm.yaml"
99   fi
100
101   # Make sure the correct overcloud image is available
102   if [ ! -f $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 ]; then
103       echo "${red} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 is required to execute your deployment."
104       echo "Please install the opnfv-apex package to provide this overcloud image for deployment.${reset}"
105       exit 1
106   fi
107
108   echo "Copying overcloud image to Undercloud"
109   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "rm -f overcloud-full.qcow2"
110   scp ${SSH_OPTIONS[@]} $IMAGES/overcloud-full-${SDN_IMAGE}.qcow2 "stack@$UNDERCLOUD":overcloud-full.qcow2
111
112   # disable neutron openvswitch agent from starting
113   if [[ -n "${deploy_options_array['sdn_controller']}" && "${deploy_options_array['sdn_controller']}" != 'False' ]]; then
114       echo -e "${blue}INFO: Disabling neutron-openvswitch-agent from systemd${reset}"
115       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
116       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -f /etc/systemd/system/multi-user.target.wants/neutron-openvswitch-agent.service" \
117                                                --run-command "rm -f /usr/lib/systemd/system/neutron-openvswitch-agent.service" \
118                                                -a overcloud-full.qcow2
119 EOI
120   fi
121
122   if [ "${deploy_options_array['vpn']}" == 'True' ]; then
123       echo -e "${blue}INFO: Enabling ZRPC and Quagga${reset}"
124       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
125       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y install /root/quagga/*.rpm" \
126                                                --run-command "sudo usermod -a -G quaggavt quagga" \
127                                                --run-command "sudo mkdir -p /var/run/quagga/" \
128                                                --run-command "sudo chown quagga:quagga -R /var/run/quagga/" \
129                                                --run-command "systemctl enable zrpcd" \
130                                                -a overcloud-full.qcow2
131 EOI
132   fi
133
134   # Install ovs-dpdk inside the overcloud image if it is enabled.
135   if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' || "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
136     # install dpdk packages before ovs
137     echo -e "${blue}INFO: Enabling kernel modules for dpdk inside overcloud image${reset}"
138
139     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
140       cat << EOF > vfio_pci.modules
141 #!/bin/bash
142 exec /sbin/modprobe vfio_pci >/dev/null 2>&1
143 EOF
144
145       cat << EOF > uio_pci_generic.modules
146 #!/bin/bash
147 exec /sbin/modprobe uio_pci_generic >/dev/null 2>&1
148 EOF
149
150       LIBGUESTFS_BACKEND=direct virt-customize --upload vfio_pci.modules:/etc/sysconfig/modules/ \
151                                                --upload uio_pci_generic.modules:/etc/sysconfig/modules/ \
152                                                --run-command "chmod 0755 /etc/sysconfig/modules/vfio_pci.modules" \
153                                                --run-command "chmod 0755 /etc/sysconfig/modules/uio_pci_generic.modules" \
154                                                -a overcloud-full.qcow2
155
156       if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
157         sed -i "/OS::TripleO::ComputeExtraConfigPre:/c\  OS::TripleO::ComputeExtraConfigPre: ./ovs-dpdk-preconfig.yaml" network-environment.yaml
158       fi
159
160 EOI
161
162   elif [ "${deploy_options_array['dataplane']}" != 'ovs' ]; then
163     echo "${red}${deploy_options_array['dataplane']} not supported${reset}"
164     exit 1
165   fi
166
167   if [ "$debug" == 'TRUE' ]; then
168     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" "LIBGUESTFS_BACKEND=direct virt-customize -a overcloud-full.qcow2 --root-password password:opnfvapex"
169   fi
170
171   # upgrade ovs into ovs 2.5.90 with NSH function if SFC is enabled
172   if [[ "${deploy_options_array['sfc']}" == 'True' && "${deploy_options_array['dataplane']}" == 'ovs' ]]; then
173     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
174          LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum install -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_kmod_rpm_name}" \
175                                                   --run-command "yum upgrade -y /root/ovs/rpm/rpmbuild/RPMS/x86_64/${ovs_rpm_name}" \
176                                                   -a overcloud-full.qcow2
177 EOI
178   fi
179
180   # Patch neutron with using OVS external interface for router and add generic linux NS interface driver
181   if [[ "${deploy_options_array['dataplane']}" == 'fdio' ]]; then
182     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
183       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /usr/lib/python2.7/site-packages/ && patch -p1 < neutron-patch-NSDriver.patch" \
184                                                -a overcloud-full.qcow2
185 EOI
186
187     # Disable clustering for ODL FDIO HA scenarios
188     if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
189       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
190       LIBGUESTFS_BACKEND=direct virt-customize --run-command "cd /etc/puppet/modules/tripleo/ && patch -p1 < disable_odl_clustering.patch" \
191                                                -a overcloud-full.qcow2
192 EOI
193     fi
194
195     # Configure routing node for odl-fdio
196     if [[ "${deploy_options_array['sdn_l3']}" == 'True' ]]; then
197       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
198         sed -i "/opendaylight::vpp_routing_node:/c\    opendaylight::vpp_routing_node: ${deploy_options_array['odl_vpp_routing_node']}.${domain_name}" ${ENV_FILE}
199 EOI
200     fi
201   fi
202
203   if [ -n "${deploy_options_array['performance']}" ]; then
204     ovs_dpdk_perf_flag="False"
205     for option in "${performance_options[@]}" ; do
206       if [ "${arr[1]}" == "vpp" ]; then
207         if [ "${arr[0]}" == "Compute" ]; then
208           role='NovaCompute'
209         else
210           role=${arr[0]}
211         fi
212         if [ "${arr[2]}" == "main-core" ]; then
213           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
214             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_main_core: \"'${arr[3]}'\"" ${ENV_FILE}
215 EOI
216         elif [ "${arr[2]}" == "corelist-workers" ]; then
217           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
218             sed -i "/${role}ExtraConfig:/ c\  ${role}ExtraConfig:\n    fdio::vpp_cpu_corelist_workers: \"'${arr[3]}'\"" ${ENV_FILE}
219 EOI
220         fi
221       fi
222       arr=($option)
223       # use compute's kernel settings for all nodes for now.
224       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "kernel" ]; then
225         kernel_args+=" ${arr[2]}=${arr[3]}"
226       fi
227       if [ "${arr[0]}" == "Compute" ] && [ "${arr[1]}" == "ovs" ]; then
228          eval "${arr[2]}=${arr[3]}"
229          ovs_dpdk_perf_flag="True"
230       fi
231     done
232
233     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
234       sed -i "/ComputeKernelArgs:/c\  ComputeKernelArgs: '$kernel_args'" ${ENV_FILE}
235       sed -i "$ a\resource_registry:\n  OS::TripleO::NodeUserData: first-boot.yaml" ${ENV_FILE}
236       sed -i "/NovaSchedulerDefaultFilters:/c\  NovaSchedulerDefaultFilters: 'RamFilter,ComputeFilter,AvailabilityZoneFilter,ComputeCapabilitiesFilter,ImagePropertiesFilter,NUMATopologyFilter'" ${ENV_FILE}
237 EOI
238
239     if [[ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' && "$ovs_dpdk_perf_flag" == "True" ]]; then
240       for ovs_option in ${!ovs_option_heat_arr[@]}; do
241         if [ -n "${!ovs_option}" ]; then
242           ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
243             sed -i "/${ovs_option_heat_arr[$ovs_option]}:/c\  ${ovs_option_heat_arr[$ovs_option]}: ${!ovs_option}" ${ENV_FILE}
244 EOI
245         fi
246       done
247     fi
248   fi
249
250   if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
251     if [ "${deploy_options_array['dataplane']}" == "fdio" ]; then
252       if [ "$tenant_nic_mapping_controller_members" == "$tenant_nic_mapping_compute_members" ]; then
253         echo -e "${blue}INFO: nosdn fdio deployment...installing correct vpp packages...${reset}"
254         ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
255           sed -i "/NeutronVPPAgentPhysnets:/c\  NeutronVPPAgentPhysnets: 'datacentre:${tenant_nic_mapping_controller_members}'" ${ENV_FILE}
256 EOI
257       else
258         echo -e "${red}Compute and Controller must use the same tenant nic name, please modify network setting file.${reset}"
259         exit 1
260       fi
261     fi
262   fi
263
264   # Set ODL version accordingly
265   if [[ "${deploy_options_array['sdn_controller']}" == 'opendaylight' && -n "${deploy_options_array['odl_version']}" ]]; then
266     case "${deploy_options_array['odl_version']}" in
267       beryllium) odl_version=''
268               ;;
269       boron)  odl_version='boron'
270               ;;
271       carbon) odl_version='master'
272               ;;
273       *) echo -e "${red}Invalid ODL version ${deploy_options_array['odl_version']}.  Please use 'carbon' or 'boron' values.${reset}"
274          exit 1
275          ;;
276     esac
277
278     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
279       LIBGUESTFS_BACKEND=direct virt-customize --run-command "yum -y remove opendaylight" \
280                                                --run-command "yum -y install /root/${odl_version}/*" \
281                                                -a overcloud-full.qcow2
282 EOI
283   fi
284
285   # Override ODL if we enable netvirt for fdio
286   if [[ "${deploy_options_array['odl_vpp_netvirt']}" == 'True' && "${deploy_options_array['sdn_controller']}" == 'opendaylight' ]]; then
287     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
288       LIBGUESTFS_BACKEND=direct virt-customize --run-command "rm -rf /opt/opendaylight/*" \
289                                                --run-command "tar zxvf /root/odl-netvirt-vpp-distribution.tar.gz -C /opt/opendaylight/" \
290                                                -a overcloud-full.qcow2
291 EOI
292   fi
293
294   # check if ceph should be enabled
295   if [ "${deploy_options_array['ceph']}" == 'True' ]; then
296     DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/storage-environment.yaml"
297   fi
298
299   if [ "${deploy_options_array['sdn_controller']}" == 'ovn' ]; then
300     # The epoch in deloran's ovs is 1: and in leif's is 0:
301     # so we have to execute a downgrade instead of an update
302     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
303       LIBGUESTFS_BACKEND=direct virt-customize \
304         --run-command "cd /root/ovs27 && yum update -y *openvswitch*" \
305         --run-command "cd /root/ovs27 && yum downgrade -y *openvswitch*" \
306         -a overcloud-full.qcow2
307 EOI
308   fi
309
310   # get number of nodes available in inventory
311   num_control_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:control /home/stack/instackenv.json")
312   num_compute_nodes=$(ssh -T ${SSH_OPTIONS[@]} "root@$UNDERCLOUD" "grep -c profile:compute /home/stack/instackenv.json")
313
314   # check if HA is enabled
315   if [[ "$ha_enabled" == "True" ]]; then
316     if [ "$num_control_nodes" -lt 3 ]; then
317       echo -e "${red}ERROR: Number of control nodes in inventory is less than 3 and HA is enabled: ${num_control_nodes}. Check your inventory file.${reset}"
318       exit 1
319     else
320      DEPLOY_OPTIONS+=" --control-scale ${num_control_nodes}"
321      DEPLOY_OPTIONS+=" -e /usr/share/openstack-tripleo-heat-templates/environments/puppet-pacemaker.yaml"
322      echo -e "${blue}INFO: Number of control nodes set for deployment: ${num_control_nodes}${reset}"
323     fi
324   else
325     if [ "$num_control_nodes" -lt 1 ]; then
326       echo -e "${red}ERROR: Number of control nodes in inventory is less than 1: ${num_control_nodes}. Check your inventory file.${reset}"
327       exit 1
328     fi
329   fi
330
331   if [ "$num_compute_nodes" -le 0 ]; then
332     echo -e "${red}ERROR: Invalid number of compute nodes: ${num_compute_nodes}. Check your inventory file.${reset}"
333     exit 1
334   else
335     echo -e "${blue}INFO: Number of compute nodes set for deployment: ${num_compute_nodes}${reset}"
336     DEPLOY_OPTIONS+=" --compute-scale ${num_compute_nodes}"
337   fi
338
339   DEPLOY_OPTIONS+=" --ntp-server $ntp_server"
340
341   DEPLOY_OPTIONS+=" --control-flavor control --compute-flavor compute"
342   if [[ "$virtual" == "TRUE" ]]; then
343      DEPLOY_OPTIONS+=" -e virtual-environment.yaml"
344   fi
345
346   echo -e "${blue}INFO: Deploy options set:\n${DEPLOY_OPTIONS}${reset}"
347
348   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
349 # Create a key for use by nova for live migration
350 echo "Creating nova SSH key for nova resize support"
351 ssh-keygen -f nova_id_rsa -b 1024 -P ""
352 public_key=\'\$(cat nova_id_rsa.pub | cut -d ' ' -f 2)\'
353 sed -i "s#replace_public_key:#key: \$public_key#g" ${ENV_FILE}
354 python -c 'open("opnfv-environment-new.yaml", "w").write((open("${ENV_FILE}").read().replace("replace_private_key:", "key: \"" + "".join(open("nova_id_rsa").readlines()).replace("\\n","\\\n") + "\"")))'
355 mv -f opnfv-environment-new.yaml ${ENV_FILE}
356
357 source stackrc
358 set -o errexit
359 # Workaround for APEX-207 where sometimes swift proxy is down
360 if ! sudo systemctl status openstack-swift-proxy > /dev/null; then
361   sudo systemctl restart openstack-swift-proxy
362 fi
363 echo "Uploading overcloud glance images"
364 openstack overcloud image upload
365
366 echo "Configuring undercloud and discovering nodes"
367 openstack baremetal import --json instackenv.json
368
369 if [[ -z "$virtual" ]]; then
370   openstack baremetal introspection bulk start
371   if [[ -n "$root_disk_list" ]]; then
372     openstack baremetal configure boot --root-device=${root_disk_list}
373   else
374     openstack baremetal configure boot
375   fi
376 else
377   openstack baremetal configure boot
378 fi
379
380 echo "Configuring flavors"
381 for flavor in baremetal control compute; do
382   echo -e "${blue}INFO: Updating flavor: \${flavor}${reset}"
383   if openstack flavor list | grep \${flavor}; then
384     openstack flavor delete \${flavor}
385   fi
386   openstack flavor create --id auto --ram 4096 --disk 39 --vcpus 1 \${flavor}
387   if ! openstack flavor list | grep \${flavor}; then
388     echo -e "${red}ERROR: Unable to create flavor \${flavor}${reset}"
389   fi
390 done
391 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" baremetal
392 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="control" control
393 openstack flavor set --property "cpu_arch"="x86_64" --property "capabilities:boot_option"="local" --property "capabilities:profile"="compute" compute
394 echo "Configuring nameserver on ctlplane network"
395 dns_server_ext=''
396 for dns_server in ${dns_servers}; do
397   dns_server_ext="\${dns_server_ext} --dns-nameserver \${dns_server}"
398 done
399 neutron subnet-update \$(neutron subnet-list | grep -Ev "id|tenant|external|storage" | grep -v \\\\-\\\\- | awk {'print \$2'}) \${dns_server_ext}
400 sed -i '/CloudDomain:/c\  CloudDomain: '${domain_name} ${ENV_FILE}
401 echo "Executing overcloud deployment, this should run for an extended period without output."
402 sleep 60 #wait for Hypervisor stats to check-in to nova
403 # save deploy command so it can be used for debugging
404 cat > deploy_command << EOF
405 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
406 EOF
407 EOI
408
409   if [ "$interactive" == "TRUE" ]; then
410     if ! prompt_user "Overcloud Deployment"; then
411       echo -e "${blue}INFO: User requests exit${reset}"
412       exit 0
413     fi
414   fi
415
416   ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
417 source stackrc
418 openstack overcloud deploy --templates $DEPLOY_OPTIONS --timeout 90
419 if ! openstack stack list | grep CREATE_COMPLETE 1>/dev/null; then
420   $(typeset -f debug_stack)
421   debug_stack
422   exit 1
423 fi
424 EOI
425
426   # Configure DPDK and restart ovs agent after bringing up br-phy
427   if [ "${deploy_options_array['dataplane']}" == 'ovs_dpdk' ]; then
428     ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI || (echo "DPDK config failed, exiting..."; exit 1)
429 source stackrc
430 set -o errexit
431 for node in \$(nova list | grep novacompute | grep -Eo "[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+"); do
432 echo "Checking DPDK status and bringing up br-phy on \$node"
433 ssh -T ${SSH_OPTIONS[@]} "heat-admin@\$node" <<EOF
434 set -o errexit
435 sudo dpdk-devbind -s
436 sudo ifup br-phy
437 if [[ -z "${deploy_options_array['sdn_controller']}" || "${deploy_options_array['sdn_controller']}" == 'False' ]]; then
438   echo "Restarting openvswitch agent to pick up VXLAN tunneling"
439   sudo systemctl restart neutron-openvswitch-agent
440 fi
441 EOF
442 done
443 EOI
444   fi
445
446   if [ "$debug" == 'TRUE' ]; then
447       ssh -T ${SSH_OPTIONS[@]} "stack@$UNDERCLOUD" <<EOI
448 source overcloudrc
449 echo "Keystone Endpoint List:"
450 openstack endpoint list
451 echo "Keystone Service List"
452 openstack service list
453 EOI
454   fi
455 }